#include <iostream>
#include <cstdio>
#include <cassert>
#include <windows.h>
#include <specstrings.h>
#include <psapi.h>

#pragma comment (lib, "psapi.lib")

SIZE_T g_TrimThreshold;
inline void ____Trim____()
{
	PROCESS_MEMORY_COUNTERS memInfo = {0};
	GetProcessMemoryInfo( GetCurrentProcess(), &memInfo, sizeof(memInfo) );

    // 臒l𒴂Ăg~Os
	if( memInfo.WorkingSetSize >= g_TrimThreshold )
	{
		SetProcessWorkingSetSize( GetCurrentProcess(), (SIZE_T)-1, (SIZE_T)-1 );
	}
}

template<typename T>
void qs( __inout_ecount(numData) T* data, 
		 __in  int numData )
{
	assert(numData >= 0);
	switch( numData )
	{
	case 0:
	case 1:
		return;
	case 2:
		if( data[0] > data[1] ) std::swap( data[0], data[1] );
		return;
	default:
		std::swap( data[0], data[numData/2] );
		____Trim____();
		const T& pivot = data[0];
		int first = 1;
		int last = numData;
		while( last - first > 1 )
		{
			if( data[first] > pivot )
			{
			    std::swap( data[first], data[last-1] );
			    ____Trim____();
				--last;
			}
			else
			{
				++first;
			}
		}
		assert( last - first == 1 );
		const int center = data[first] > pivot ? first - 1 : first;
		std::swap( data[0], data[center] );
		____Trim____();
		qs( data, center );
		____Trim____();
		qs( data + center + 1, numData - center - 1 );
		return;
	}
}


int wmain()
{
	PROCESS_MEMORY_COUNTERS memInfo = {0};
	GetProcessMemoryInfo( GetCurrentProcess(), &memInfo, sizeof(memInfo) );

	std::wcout << L"Initial Peak Working Set Size:  " << memInfo.PeakWorkingSetSize / 1024 << L" K" << std::endl;

    //  PeakWorkingSetSize  75% 𒴂g~OsƂɂ
	g_TrimThreshold = memInfo.PeakWorkingSetSize * 3 /4;

	srand( GetTickCount() );
	const int numArray = 1024*1024*16;
	int* buf = (int*) VirtualAlloc( NULL, numArray * sizeof(int), MEM_COMMIT, PAGE_READWRITE );
	for( int i = 0; i < numArray; ++i )
	{
		____Trim____();
		buf[i] = rand();
	}
	qs( buf, numArray );

	GetProcessMemoryInfo( GetCurrentProcess(), &memInfo, sizeof(memInfo) );
	std::wcout << L"Last Peak Working Set Size:  " << memInfo.PeakWorkingSetSize / 1024 << L" K" << std::endl;

	for( int i = 0; i < numArray-1; ++i )
	{
		if( !(buf[i] <= buf[i+1]) )
		{
			DebugBreak();
		}
	}

	return 0;
}